#!/bin/zsh
# (c) Nei <anti.teamidiot.de>

. ./sbd.config.lib.zsh

for ((;;)) {
	nothing=0
	temp_file=($qdir/<->(-m.pdf|.ocr|.img|.collect)(Nn[1]))
	if [[ $#temp_file -eq 1 ]] {
		date
		echo '>' $temp_file
		if [[ $temp_file:e == (ocr|img) ]] {
			:>|$temp_file:r.html
			if [[ $temp_file:e == ocr ]] {
				tesseract $temp_file $temp_file:r hocr
			}
			./hocr2pdf -i $temp_file -o $qdir/$temp_file:t:r.pdf -s < $temp_file:r.html
			rm -f $temp_file $temp_file:r.html
		} \
		elif [[ $temp_file:e == collect ]] {
			coll_files=()
			eval "coll_files+=($qdir/<-$temp_file:t:r>.pdf(Nn))"
			if [[ $#coll_files -gt 0 ]] {
				java -cp ./Multivalent.jar tool.pdf.Merge $coll_files
				rm $coll_files			
			}
			rm -f $temp_file
		} \
		elif [[ $temp_file:e == pdf ]] {
			mv $temp_file $outdir/`date -d@${${temp_file:r:t}[1][1,-12]} +%F_%H-%M.%S`.$temp_file:e
		}
	} \
	else {
		nothing=1
	}
	pdfqueue=($qdir/<->.pdf(Nn))
	if [[ $nothing -eq 0 ]] {
		allqueue=($qdir/*(NON))
		((imgqueue_no=$#allqueue-$#pdfqueue))
		unix2dos > /tmp/sbd-Info.txt <<EOF
`date`
=============================
Seiten in der Warteschlange: $imgqueue_no
Seiten im Zwischenspeicher:  $#pdfqueue

Zuletzt durchgefuehrte Aktion: $temp_file:t

Betaetigen Sie den Zusammenfg. Button am Scanner, um die Seiten aus dem
Zwischenspeicher in ein Dokument zu ueberfuehren.

Mit freundlichen Gruessen,
Das Scanner Warteschlangen-Bediensystem 

EOF
		mv -f /tmp/sbd-Info.txt $outdir/Info.txt
	} \
	else {
		dosleep=1
		if [[ $#pdfqueue -gt 0 ]] {
			ts=`date +%s%N`
			seconds=$ts[1,-10]
			last_seconds=${${pdfqueue:r:t}[-1][1,-10]}
			if [[ $((seconds-last_seconds)) -gt $autocollect_time ]] {
				touch $qdir/$ts.collect
				dosleep=0
				echo autocollect @
			}
		} \
		elif [[ -e $outdir/Info.txt ]] {
			rm -f $outdir/Info.txt
		}
		if [[ $dosleep -eq 1 ]] {
			sleep 1
		}
	}
}
